import java.util.Scanner;

public class CetvrtiZadatakTakmicenje 
{
    public static void main(String[] args)
    {
        Scanner unos = new Scanner(System.in);
        
        int brucesnika = unos.nextInt();
        int broj = unos.nextInt();
        int []arrayUcesnci = new int [2 * brucesnika];
        
        int s = 0;
        
        for (int i = 0; i < brucesnika; i++)
        {
            arrayUcesnci[i] = unos.nextInt();
        }
        
        for (int i = brucesnika; i < 2 * brucesnika; i++)
        {
            arrayUcesnci[i] = 0;
        }
        
        int brucesnika1 = brucesnika;
        
        if(broj != 0)
        {
            for (int i = 0; i < brucesnika1; i++)
            {
                for (int j = 0; j < brucesnika; j++)
                {
                    for (int k = 0; k <= j; k++)
                    {
                        s = s + arrayUcesnci[k];
                    }
                }
                
                for (int p = 0; p < brucesnika; p++)
                {
                    arrayUcesnci[p] = arrayUcesnci[p+1];
                }
                brucesnika--;
            }
            s = s * broj;
        }
        
        else
        {
            for (int i = 0; i < brucesnika; i++)
            {
                s = s + arrayUcesnci[i];
            }
        }
        
        s = s % (1000000000 + 7);
        
        System.out.println(s);
        
    }
    
}